﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using MVCGrid.Models;

namespace MVCGrid.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewData["SupplierID"] = SupplierID;            
            return View();            
        }

        public ActionResult BatchDataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable DataSource = OrderRepository.GetAllRecords().ToList();
            BatchDataResult result = new BatchDataResult();
            DataOperations obj = new DataOperations();
            if (dm.Skip != 0)
            {
                DataSource = obj.PerformSkip(DataSource, dm.Skip);
            }
            if (dm.Take != 0)
            {
                DataSource = obj.PerformTake(DataSource, dm.Take);
            }
            result.result = DataSource;
            result.count = DataSource.AsQueryable().Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class BatchDataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
        public ActionResult BatchUpdate(List<EditableOrder> changed, List<EditableOrder> added, List<EditableOrder> deleted, List<EditableForm> Form)
        {
            simpledbEntities3 db = new simpledbEntities3();
            if (changed != null)
                OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            if (added != null)
                OrderRepository.Add(added);
            if (Form != null)
                SalesRepository.Add(Form);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public List<object> SupplierID
        {
            get
            {
                var supplierID = new simpledbEntities3().SupplierDetails.Select(e => e.SupplierID).Distinct().ToList();
                var SupplierID = new List<object>();
                foreach (var id in supplierID)
                {
                    SupplierID.Add(new { value = id, text = id });
                }
                return SupplierID;
            }
        }
    }
}