#region Copyright Syncfusion Inc. 2001 - 2014
// Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
namespace MVCSampleBrowser.Models
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web;
    using MVCSampleBrowser.Models;
    using MVCGrid;
    using MVCGrid.Models;
    using System.Data.Entity;


    public static class OrderRepository
    {
        public static IList<EditableOrder> GetAllRecords()
        {
            IList<EditableOrder> orders = (IList<EditableOrder>)HttpContext.Current.Session["Orders"];

            if (orders == null)
            {
                HttpContext.Current.Session["Orders"] = orders = (from ord in new simpledbEntities3().SalesDetails
                                                                  select new EditableOrder
                                                                  {
                                                                      ReferenceNo = ord.ReferenceNo,
                                                                      ItemName = ord.ItemName,
                                                                      SupplierID = ord.SupplierID,
                                                                      Quantity = ord.Quantity,
                                                                      UnitPrice = ord.UnitPrice
                                                                  }).ToList();
                
            }
            return orders;
        }

        public static void Add(EditableOrder order)
        {
            GetAllRecords().Insert(0, order);
        }

        public static void Add(List<EditableOrder> order)
        {
            simpledbEntities3 db = new simpledbEntities3();
            foreach(var temp in order){
                GetAllRecords().Insert(0, temp);
                SalesDetail s=new SalesDetail(); 
                s.ReferenceNo=temp.ReferenceNo; 
                s.ItemName=temp.ItemName;
                s.SupplierID = temp.SupplierID;
                s.Quantity = temp.Quantity;
                s.UnitPrice = temp.UnitPrice;
                db.SalesDetails.Add(s);
                db.SaveChanges();
            }
        }

        public static void Delete(int OrderID)
        {
            EditableOrder result = GetAllRecords().Where(o => o.ReferenceNo == OrderID).FirstOrDefault();
            GetAllRecords().Remove(result);
        }

        public static void Delete(List<EditableOrder> order)
        {
            simpledbEntities3 db = new simpledbEntities3();
            foreach (var temp in order)
            {
                EditableOrder result = GetAllRecords().Where(o => o.ReferenceNo == temp.ReferenceNo).FirstOrDefault();
                GetAllRecords().Remove(result);
                var data = db.SalesDetails.Find(temp.ReferenceNo);
                if(data != null)
                    db.SalesDetails.Remove(data);
                db.SaveChanges();
            }            
        }
   

        public static void Update(List<EditableOrder> order)
        {
            simpledbEntities3 db = new simpledbEntities3();
            foreach (var temp in order)
            {
                EditableOrder result = GetAllRecords().Where(o => o.ReferenceNo == temp.ReferenceNo).FirstOrDefault();
                if (result != null)
                {
                    result.ReferenceNo = temp.ReferenceNo;
                    result.ItemName = temp.ItemName;
                    result.Quantity = temp.Quantity;
                    result.UnitPrice = temp.UnitPrice;
                }
                SalesDetail s = new SalesDetail();
                s.ReferenceNo = temp.ReferenceNo;
                s.ItemName = temp.ItemName;
                s.SupplierID = temp.SupplierID;
                s.Quantity = temp.Quantity;
                s.UnitPrice = temp.UnitPrice;
                db.Entry(s).State = EntityState.Modified;
                db.SaveChanges();
            }
        }
    }
}
